%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%								%
% Definieren Sie ein Prädikat greater_than/2, das zwei 		%
% natürliche Zahlen in der succ/1-Notation nimmt und		%
% überprüft, ob die erste Zahl größerist als die zweite.	%
%								%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Lösung 

% greater_than/2
% Oben steht die Basisklausel. Wenn das erste Argument irgendetwas mit succ-Notation (also 
% irgendwas groesser 0) ist, und das rechte Argument 0 ist, ist das erste Argument groesser als
% das zweite und wir koennen aufhoeren zu suchen.
% In der zweiten Klausel steht der rekursive Fall.
% Wenn beide Zahlen in succ-Notation sind, ist der Basisfall noch nicht erreicht. Deshalb wird
% im Regelkoerper untersucht, ob die greater_than Beziehung zwischen den Vorgaengern von
% succ(X) und succ(Y) gilt. Was X und Y ist, wissen wir an dieser Stelle nicht genau.
% Es wird einfach an den nächsten rekursiven Aufruf weitergegeben. 

greater_than(succ(X),0).				% Wenn succ(X) größer als 0 ist, wird die Suche beendet.
greater_than(succ(X),succ(Y)):-				% succ(X) ist größer als succ(Y), wenn
	greater_than(X,Y).				% X größer als Y ist. 

% Beispielanfragen mit dem trace-Modus ausfuehren:
% greater_than(succ(succ(0)),0).
% greater_than(succ(succ(0)),succ(0)).
% greater_than(0,succ(succ(0))).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Alternativer Loesungsweg: 
% Es reicht, eine Lösung verstanden zu haben! 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
greater_than1(succ(X),X).				% Wenn succ(X) um genau 1 größer ist als X, wird die Suche beendet.
greater_than1(succ(X),Y) :- 				% succ(X) ist um genau 1 größer als Y, wenn
    greater_than1(X,Y).					% X um genau 1 größer als Y ist.

% Basisklausel: irgendeine positive Zahl succ(X) ist groesser 
% als die Zahl X, die genau eins kleiner ist als succ(X).
% Rekursive Klausel: 
% Das erste Argument soll groesser als das zweite sein, damit das
% Praedikat Erfolg hat. 
% Also geben wir das zweite Argument unveraendert an den rekursiven Aufruf weiter,
% Das erste Argument wird um eins reduziert, indem im Regelkopf succ(X) steht und im Regelaufruf X. 
% Das erste Argument wird solange um eins reduziert, bis es genau eins groesser ist als das zweite Argument (Basisklausel).
% 1. Beispiel: greater_than1(succ(succ(0)),succ(0)). Hat sofort Erfolg (Basisklausel)
% 2. Beispiel: greater_than1(succ(succ(0)),0). geht in die zweite Klausel
% und macht den rekursiven Aufruf greater_than1(succ(0),0), der dann in der Basisklausel
% wahr wird.
% Die selben Anfragen wie oben, nur mit greater_than1... statt greater_than...
