
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                               %
% Aufgabe: swap/2                                                               %        
% Binärbäume sind Bäume, bei denen alle internen Knoten genau zwei Kinder       %
% enthalten. Die kleinsten Binärbäume bestehen aus nur einem Blatt. Wir werden  %
% Blätter als leaf(Label) darstellen. Zum Beispiel sind leaf(3) und leaf(7)     %
% Blätter und damit minimale Binärbäume. Bei zwei Binärbäumen B1 und B2 können  %
% wir sie mit dem Functor Tree/2 wie folgt zu einem Binärbaum kombinieren:      %
% tree(B1,B2) .                                                                 %
% So können wir aus den Blättern leaf(1) und leaf(2) den Binärbaum              %
% tree(leaf(1),leaf(2)) bauen. Und aus den Binärbäumen tree(leaf(1), leaf(2))   %
% und leaf(4) können wir den Binärbaum tree(tree(leaf(1), leaf(2)), leaf(4))    %
% bauen.                                                                        %
%                                                                               %
% Definieren Sie nun ein Prädikat swap/2, der das Spiegelbild des               %
% Binärbaums erzeugt, das sein erstes Argument ist. Zum Beispiel:               %
%   ?-  swap(tree(tree(leaf(1),  leaf(2)),  leaf(4)),T).                        %
%    T  =  tree(leaf(4),  tree(leaf(2),  leaf(1))).                             %
%    yes                                                                        %
%                                                                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Loesung


% .      geswappt gibt   .
% |\                     |\
% | \                    | \
% 1  2                   2 1

% Dabei sind 1 und 2 die leaves und die internen Knoten 
% (hier nur die Wurzel) haben kein Label.

% Der Algorithmus von swap/2 geht top-down vor, d.h. man wirft den ganzen Baum rein und 
% arbeitet sich von oben nach unten vor.
% Basisfall: ein einzelnes Blatt geswappt ist das selbe Blatt, Reihenfolge aendert sich nicht

swap(leaf(X),leaf(X)).                              % leaf(X) wird mit leaf(X) getauscht. Da es das selbe Blatt ist, gibt es keine Veränderung.

% rekursiver Fall: ein Baum
% .      geswappt gibt   .
% |\                     |\
% | \                    | \
% X  Y               swapY  swapX
% Der Punkt . steht dabei fuer tree(...) 
% X und Y sind beliebige Blaetter oder groessere Teilbaeume. 
% Diese mussen auch gespiegelt werden. Das geschieht im Regelkoerper. 
% Dabei kommt dann swapX bzw. swapY heraus.

swap(tree(X,Y), tree(SwapY, SwapX)) :-              % Eine Baumstruktur kann getauscht werden, wenn
    swap(X, SwapX),                                 % X mit SwapX getauscht wird und
    swap(Y,SwapY).                                  % Y mit SwapY getauscht wird.



