%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% trainFromTo/2                                                                                                     %
%                                                                                                                   %
% In dieser Wissensbasis stehen Fakten über verschiedene Städte, zwischen denen eine                                %
% direkte Zugverbindung besteht. Aber natürlich kann man noch weiter reisen, indem                                  %
% man verschiedene direkte Verbindungen aneinanderreiht. Schreibe ein rekursives                                    %   
% Prädikat travelFromTo/2 mit dem festgestellt werden kann, ob man zwischen zwei                                    %
% Städten reisen kann. Zum Beispiel, gegeben die folgende Suchanfrage                                               %
% travelFromTo(nancy,saarbruecken).    sollte                                                                       %
% true.                                                                                                             %   
% zurückgegeben werden.                                                                                             %
%                                                                                                                   %
% directTrain(saarbruecken,dudweiler).       % Es gibt eine direkte Zugverbindung von Saarbrücken nach Dudweiler.   %
% directTrain(forbach,saarbruecken).         % Es gibt eine direkte Zugverbindung von Forbach nach Saarbrücken.     %
% directTrain(freyming,forbach).             % Es gibt eine direkte Zugverbindung von Freyming nach Forbach.        %
% directTrain(stAvold,freyming).             % Es gibt eine direkte Zugverbindung von St. Avold nach Freyming.      %
% directTrain(fahlquemont,stAvold).          % Es gibt eine direkte Zugverbindung von Fahlquemont nach St. Avold.   %
% directTrain(metz,fahlquemont).             % Es gibt eine direkte Zugverbindung von Metz nach Fahlquemont.        %
% directTrain(nancy,metz).                   % Es gibt eine direkte Zugverbindung von Nancy nach Metz.              %
%                                                                                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Loesung

% Basisfall: Es gibt einen direkten Zug zwischen Start und Ziel.

travelFromTo(Start,Ziel) :-                             % Man kann vom Start zum Ziel reisen, wenn
    directTrain(Start,Ziel).                            % es eine direkte Zugverbindung vom Start zum Ziel gibt.
    
% rekursive Regel: Es gibt einen direkten Zug vom Start zum Zwischenstopp.
% rekursiver Aufruf: dann kann man vom Zwischenstopp zum Ziel reisen. Das kann ueber 
% einen direkten Zug passieren (es wird erst die Basisklausel versucht)
% oder ueber nochmaliges Umsteigen (weiteres Aufrufen der rekursiven Klausel)

travelFromTo(Start,Ziel) :-                             % Man kann vom Start zum Ziel reisen, wenn
    directTrain(Start,Zwischenstopp),                   % es eine direkte Zugverbindung vom Start zum Zwischenstopp und
    travelFromTo(Zwischenstopp,Ziel).                   % es eine Verbindung vom Zwischenstopp zum Ziel gibt.
